/*
 *  ngtk/c/ngtk_fade.c
 *
 *  Copyright (C) 1998, 1999 Gabriel Fort <gabx@tfz.net>
 *	This code is derived from Fonter v1.7, Copyright (C) 1998 Chis Monahan
 *
 */

/*----------------------------------------------------------------------------

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the 
    Free Software Foundation, Inc., 59 Temple Place - Suite 330, 
    Boston, MA  02111-1307  USA.

----------------------------------------------------------------------------*/
#include <ngtk/ngtk.h>

int default_red[] = {
	0x00, 0xaa, 0x00, 0xaa, 0x00, 0xaa, 0x00, 0xaa, 0x55, 0xff, 0x55, 0xff,
	0x55, 0xff,	0x55, 0xff
};

int default_grn[] = {
	0x00, 0x00, 0xaa, 0x55, 0x00, 0x00, 0xaa, 0xaa, 0x55, 0x55, 0xff, 0xff,
	0x55, 0x55,	0xff, 0xff
};

int default_blu[] = {
	0x00, 0x00, 0x00, 0x00, 0xaa, 0xaa, 0xaa, 0xaa, 0x55, 0x55, 0x55, 0x55,
	0xff, 0xff,	0xff, 0xff
};

int fadetime = 0;

void ngtk_fade_in(void)
{
	int steps = 64;
	unsigned long restsize;
	int i, j;
	unsigned char stepsize;
	unsigned char red, green, blue;

	if (can_change_color) {
		stepsize = 256 / steps;
		restsize = 1000 * fadetime / steps;

		for (i=0;i<=255;i+=stepsize) {
			printf("\e[A");
			fflush(stdout);
			for (j=0;j<=15;j++) {
				red = default_red[j] * i / 256;
				green = default_grn[j] * i / 256;
				blue = default_blu[j] * i / 256;
				printf("\e]P%1X%02X%02X%02X", j, red, green, blue);
			}
			usleep(restsize);
		}
		printf("\e]R");
	}
}

void ngtk_fade_out(void)
{
	int steps = 64;
	unsigned long restsize;
	int i, j;
	unsigned char stepsize;
	unsigned char red, green, blue;

	if (can_change_color) {
		stepsize = 256 / steps;
		restsize = 1000 * fadetime / steps;

		for (i=256;i>=0;i-=stepsize) {
			printf("\e[A");
			fflush(stdout);
			for (j=0;j<=15;j++) {
				red = default_red[j] * i / 256;
				green = default_grn[j] * i / 256;
				blue = default_blu[j] * i / 256;
				printf("\e]P%1X%02X%02X%02X", j, red, green, blue);
			}
			usleep(restsize);
		}
	}
}
