/*
 *  ngtk/test/radio_test.c
 *
 *  Copyright (C) 1998, 1999 Gabriel Fort <gabx@tfz.net>
 *
 */

/*----------------------------------------------------------------------------
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
----------------------------------------------------------------------------*/
#include <ngtk/ngtk.h>
#include "ngtk_test.h"

void cleanup_radio_test(void)
{
    ngtk_topbar(56, A_NORMAL, version_info, 0);
}

void radio_test(void)
{
    char *choices[3] = { "Item #1", "Item #2", "Item #3" };
    int ids[3] = { 0, 1, 2 };
	ngtk_radio_t *radio;

    ngtk_topbar(BLACK_F(WHITE_B), A_NORMAL, " Radio Box Test, Up/Down: move selection, Enter: select, Esc: cancel", 0);

	radio = ngtk_mk_radio("Choose an Item", 3, choices, ids);

	ngtk_auto_show_radio(radio, BLACK_F(WHITE_B), A_NORMAL, 1, 0);

	ngtk_manage_radio(radio);
	ngtk_hide_radio(radio);

	if (radio->current_item != -1)
	    ngtk_commonbox(BLACK_F(WHITE_B), A_NORMAL, "Returned Choice", \
					   "You Choosed : ", choices[radio->current_item]);

	ngtk_destroy_radio(radio);

    cleanup_radio_test();
}

void init_radio_test(void)
{
    ngtk_register_key(NGTK_KEY_F(2), radio_test, "F2", "Radio", 1);
}
